import path from "path";
import fs from "fs";
import { MAIN_ENTRY_NAME, SERVER_BUNDLE_DIRECTORY } from "@alola-react/utils";
import { matchEntry } from "@alola-react/runtime-utils/node";
var server_default = () => ({
  name: "@alola-react/plugin-data-loader",
  setup: () => ({
    prepareLoaderHandler({ serverRoutes, distDir }) {
      return async (context) => {
        const entry = matchEntry(context.path, serverRoutes);
        if (!entry) {
          return;
        }
        const routesPath = path.join(distDir, SERVER_BUNDLE_DIRECTORY, `${entry.entryName || MAIN_ENTRY_NAME}-server-loaders.js`);
        if (!fs.existsSync(routesPath)) {
          return;
        }
        const { routes, handleRequest } = await import(routesPath);
        if (!routes) {
          return;
        }
        return handleRequest({
          serverRoutes,
          context,
          routes
        });
      };
    }
  })
});
export {
  server_default as default
};
