import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import path from "path";
import fs from "fs";
import { MAIN_ENTRY_NAME, SERVER_BUNDLE_DIRECTORY } from "@alola-react/utils";
import { matchEntry } from "@alola-react/runtime-utils/node";
function server_default() {
  return {
    name: "@alola-react/plugin-data-loader",
    setup: function() {
      return {
        prepareLoaderHandler: function prepareLoaderHandler(param) {
          var serverRoutes = param.serverRoutes, distDir = param.distDir;
          return function() {
            var _ref = _async_to_generator(function(context) {
              var entry, routesPath, _ref2, routes, handleRequest;
              return _ts_generator(this, function(_state) {
                switch (_state.label) {
                  case 0:
                    entry = matchEntry(context.path, serverRoutes);
                    if (!entry) {
                      return [
                        2
                      ];
                    }
                    routesPath = path.join(distDir, SERVER_BUNDLE_DIRECTORY, "".concat(entry.entryName || MAIN_ENTRY_NAME, "-server-loaders.js"));
                    if (!fs.existsSync(routesPath)) {
                      return [
                        2
                      ];
                    }
                    return [
                      4,
                      import(routesPath)
                    ];
                  case 1:
                    _ref2 = _state.sent(), routes = _ref2.routes, handleRequest = _ref2.handleRequest;
                    if (!routes) {
                      return [
                        2
                      ];
                    }
                    return [
                      2,
                      handleRequest({
                        serverRoutes,
                        context,
                        routes
                      })
                    ];
                }
              });
            });
            return function(context) {
              return _ref.apply(this, arguments);
            };
          }();
        }
      };
    }
  };
}
;
export {
  server_default as default
};
